
import http from '@/utils/request'
// import axios from 'axios'

// 获取ddl 旧版
export function getDDL (params) {
  return http.post('/dataFactory/data/meta/data/combination/ddl', params)
}

// 元数据相关
const metadata = {
  // 新增元数据
  metadataAdd (params) {
    return http.post('/DataOps-platform/meta/node/add', params)
  },
  // 更新元数据
  metadataUpdate (params) {
    return http.post('/DataOps-platform/meta/node/update', params)
  },
  // 删除元数据
  deleteMetadata: (param) => {
    return http.post('/DataOps-platform/meta/node/delete', param)
  },
  // 查看元数据
  getMetadataDetails: (param) => {
    return http.post('/DataOps-platform/meta/node/edit', param)
  },
  // 元数据列表
  getMetaDataList: (param) => {
    return http.post('/DataOps-platform/meta/node/list', param)
  },
  // 元数据图谱
  getMetaDataGraph: (param) => {
    return http.post('/DataOps-platform/meta/node/graph', param)
  },
  // 元数据图谱
  getMetaDataById: (param) => {
    return http.post('/DataOps-platform/id/data/search', param)
  }
}

// 数据资源
const dataResource = {
  // 资源列表
  getResourceList: (param) => {
    return http.post('/DataOps-platform/meta/data/list', param)
  },
  getResourceDetails: (param) => {
    return http.post('/DataOps-platform/data/resource/detail', param)
  },
  // 查看资源图谱
  getResourceListToGraph: (param) => {
    return http.post('/DataOps-platform/data/resource/list/graph', param)
  },
  // 结构化资源列表
  getStructureResource: (param) => {
    return http.post('/DataOps-platform/id/structure/retrieval', param)
  },
  // 非结构化资源列表
  getUnstructuredResource: (param) => {
    return http.post('/DataOps-platform/id/text/retrieval', param)
  },
  // 删除资源
  deleteSource: (param) => {
    return http.post('/DataOps-platform/data/resource/delete', param)
  },
  // 大模型模型翻译元数据
  resourceTranslate: (param) => {
    return http.formData('/DataOps-platform/data/resource/translate', param)
  },
  // 保存数据资源
  saveResource: (param) => {
    return http.post('/api/resource/save', param)
  },
  // // 保存数据资源
  // createResource: (param) => {
  //   return http.post('/api/resource/create', param)
  // },
  // // 保存数据资源
  // updateResource: (param) => {
  //   return http.put('/api/resource/update', param)
  // },
  // 数据资源上传
  uploadResource: (param) => {
    return http.upload('/DataOps-platform/data/resource/upload', param)
  },
  // 获取数据资源文件流
  getResourceFile: (param) => {
    return http.download('/DataOps-platform/data/resource/display', param)
  },
  // 解析非结构化文本展示信息
  getUnstructured: (param) => {
    return http.post('/DataOps-platform/text/resource/translate', param)
  },
  // 保存非结构化文本解析
  saveUnstructured: (param) => {
    return http.post('/DataOps-platform/text/resource/save', param)
  },
  // 获取资源血缘关系
  getResourceRelationList: (param) => {
    return http.post('/DataOps-platform/model/relatives/relation', param)
  },
  // 查看资源图谱
  getResourceGraph: (param) => {
    return http.post('/DataOps-platform/data/resource/graph/all', param)
  },
  // 查看资源图谱
  resourceParseByDDL: (param) => {
    return http.upload('/DataOps-platform/sql/ddl/identify', param)
  },
  // 更新 ddl
  resourceUpdateByDDL: (param) => {
    return http.post('/DataOps-platform/data/resource/update', param)
  }
}

// 数据模型
const dataModel = {
  // 血缘关系查看
  getModelRelation: (param) => {
    return http.post('/DataOps-platform/model/data/relation', param)
  },
  // 模型列表
  getModelList: (param) => {
    return http.post('/DataOps-platform/data/model/list', param)
  },
  getModelDetails: (param) => {
    return http.post('/DataOps-platform/data/model/detail', param)
  },
  // 查看模型图谱
  getModelListToGraph: (param) => {
    return http.post('/DataOps-platform/data/model/list/graph', param)
  },
  // 保存模型
  saveModel: (param) => {
    return http.post('/DataOps-platform/model/data/search', param)
  },
  // 删除模型
  deleteModel: (param) => {
    return http.post('/DataOps-platform/data/model/delete', param)
  },
  // 新增模型：模型选择模型
  addModelByModel: (param) => {
    return http.post('/DataOps-platform/model/data/model/add', param)
  },
  // 查看模型图谱
  getModelGraph: (param) => {
    return http.post('/DataOps-platform/data/model/graph/all', param)
  },
  updateModel: (param) => {
    return http.post('/DataOps-platform/data/model/update', param)
  },
  // addModelByDDL: (param) => {
  //   return http.post('/DataOps-platform/model/data/sql', param)
  // },
  saveModelByDDL: (param) => {
    return http.post('/DataOps-platform/data/model/save', param)
  }
}

// 数据标签
const dataLabel = {
  // 列表
  dataLabelList: (param) => {
    return http.post('/DataOps-platform/data/label/list', param)
  },
  // 新增
  dataLabelAdd: (param) => {
    return http.post('/DataOps-platform/data/label/add', param)
  },
  // 详情
  dataLabelDetails: (param) => {
    return http.post('/DataOps-platform/data/label/detail', param)
  },
  // 详情
  dataLabelGraph: (param) => {
    return http.post('/DataOps-platform/data/label/graph/all', param)
  },
  // 数据标签动态识别分组
  dataLabelIdentifyGroup: (param) => {
    return http.post('/DataOps-platform/data/label/dynamic/identify', param)
  }
}

// 数据标准
const dataStandard = {
  // 标准列表
  dataStandardList: (param) => {
    return http.post('/DataOps-platform/data/standard/list', param)
  },
  // 新增
  dataStandardAdd: (param) => {
    return http.post('/DataOps-platform/data/standard/add', param)
  },
  // 详情
  dataStandardDetails: (param) => {
    return http.post('/DataOps-platform/data/standard/detail', param)
  },
  // 生成操作代码
  dataStandardCodeGenerate: (param) => {
    return http.post('/DataOps-platform/data/standard/code', param)
  },
  // 生成操作代码
  dataStandardGraph: (param) => {
    return http.post('/DataOps-platform/data/standard/graph/all', param)
  }
}

// 数据指标
const dataIndicator = {
  // 指标列表
  dataIndicatorList: (param) => {
    return http.post('/DataOps-platform/data/metric/list', param)
  },
  // 指标列表切换图谱
  dataIndicatorListToGraph: (param) => {
    return http.post('/DataOps-platform/data/metric/list/graph', param)
  },
  // 新增指标
  dataIndicatorAdd: (param) => {
    return http.post('/DataOps-platform/data/metric/add', param)
  },
  // 新增更新
  dataIndicatorUpdate: (param) => {
    return http.post('/DataOps-platform/data/metric/update', param)
  },
  // 指标详情
  dataIndicatorDetails: (param) => {
    return http.post('/DataOps-platform/data/metric/detail', param)
  },
  // 指标血缘关系检测
  dataIndicatorRelation: (param) => {
    return http.post('/DataOps-platform/data/metric/relation', param)
  },
  dataIndicatorCodeGenerate: (param) => {
    return http.post('/DataOps-platform/data/metric/code', param)
  },
  // 指标图谱
  dataIndicatorGraph: (param) => {
    // return http.post('/DataOps-platform/data/metric/graph', param)
    return http.post('/DataOps-platform/data/metric/graph/all', param)
  }
}

const LLM = {

  // 模型训练
  setDDLTrain: (param) => {
    return http.post('/vanna/api/v0/train', param)
  },
  // 图表sql信息
  getSql: (param) => {
    return http.get('/vanna/api/v0/generate_sql', param)
  },
  // 图表sql信息
  getToTable: (param) => {
    return http.get('/vanna/api/v0/run_sql', param)
  },
  // 知识库+图谱问答
  ask: (param) => {
    return http.post('/rag/ask', param)
  },
  // 产品知识库问答 RAG
  askToProduct: (param) => {
    return http.post('/rag/ask/rag', param)
  },
  // 非结构化知识库问答 RAG + Graph
  askToUnstructured: (param) => {
    return http.post('/rag/ask/unstructure/rag', param)
  }
}

const other = {
// 资源 & 模型 列表
  getResourceAndModelList: (param) => {
    return http.post('/DataOps-platform/resource/model/list', param)
  },
  // 查看图谱
  dataGraphById: (param) => {
    return http.post('/DataOps-platform/id/data/graph', param)
  },

  // 生产线调度
  productionLineDispatch: (param) => {
    return http.post('/DataOps-platform/id/data/save', param)
  },
  // 获取资源ddl
  getDDL: (param) => {
    return http.post('/DataOps-platform/id/data/ddl', param)
  },

  // 生产线执行非结构化文档 实体 关系
  runUnstructured: (param) => {
    return http.post('/DataOps-platform/text/resource/node', param)
  },
  // 生产线执行非结构化文档 元数据内容
  runUnstructuredMetadata: (param) => {
    return http.post('/DataOps-platform/processing/unstructured/data', param)
  },
  // 产品知识库列表
  productKnowledgeBaseList: (param) => {
    return http.post('/DataOps-platform/text/product/list', param)
  },
  // 直接删除图谱元素
  graphDataDelete: (param) => {
    return http.post('/DataOps-platform/metric/label/standard/delete', param)
  },
  // 直接删除图谱元素
  getGraphMetadataById: (param) => {
    return http.post('/DataOps-platform/graph/meta/include', param)
  }
}

// 整合api
export const api = {
  // 元数据
  ...metadata,
  // 数据资源
  ...dataResource,
  // 数据模型
  ...dataModel,

  // 数据标签
  ...dataLabel,

  // 数据标准
  ...dataStandard,

  // 数据指标
  ...dataIndicator,

  // 大语言模型对话接口
  ...LLM,

  ...other

}
